#include <vector>
#include <cstdio>
#include <algorithm>

using namespace std;
#define pow(x) (((long long)x) *((long long)x))
vector <pair<int, int> > st, p;
pair<int, int> p0;
int mini;

bool cmp(pair<int, int> a, pair<int, int> b)
{
  long long r = (long long)a.first * (long long)b.second - (long long)b.first * (long long)a.second;
  if (r > 0LL)
    return true;
  if (r == 0LL && (pow(a.first) + pow(a.second) < pow(b.first) + pow(b.second)))
    return(true);
  return false;
}

void trans()
{
  for(int i = 0; i < p.size(); i++){
    p[i].first -= p0.first;
    p[i].second -= p0.second;
  }
}

bool wlewo(pair<int, int> p0, pair<int, int> p1, pair<int, int> p2)
{
  pair<int, int> x = p2, y = p1;/*nie na odwrot?*/
  y.first -= p0.first;
  y.second -= p0.second;
  x.first -= p0.first;
  x.second -=p0.second;
  long long r = (long long)x.first * (long long)y.second - (long long)x.second * (long long)y.first;
  if (r <= 0LL)
    return true;
  return false;
}

long long res()
{
  long long max = -1LL;
  int right = 1;
  /*for(int i = 0; i < st.size(); i++){
    printf("%d %d\n", st[i].first, st[i].second);
    }*/
  for(int i = 0; i < st.size(); i++){
    long long locmax = 0LL, odl;
    for(int j = right; j < st.size(); j++)
      if ((odl = pow(st[i].first - st[j].first) + pow(st[i].second -  st[j].second)) >= locmax){
	locmax = odl;
	right++;
      }
      else{
	right--;
	break;
      }
    if (locmax > max)
      max = locmax;
  }
  return max;
}
long long solve()
{
  p0 = p[mini];  
  swap(p[mini], p[p.size() - 1]);
  p.pop_back();
  trans();  
  sort(p.begin(), p.end(), cmp);
  st.clear();
  st.push_back(make_pair(0, 0));
  st.push_back(p[0]);
  st.push_back(p[1]);
  for(int i = 2; i < p.size(); i++){
    while(!wlewo(st[st.size() - 2], st.back(), p[i]))
      st.pop_back();
    st.push_back(p[i]);
  }
  return res();
}
int
main()
{
  int d, n;
  pair<int, int> newp;
  scanf("%d", &d);
  for(int i = 0; i < d; i++){
    scanf("%d", &n);
    mini = -1;
    p.clear();
    for(int j = 0; j < n; j++){
      scanf("%d%d", &newp.first, &newp.second);
      p.push_back(newp);
      if (mini == -1 || newp.second < p[mini].second)
	mini = j;
    }
    if (n == 2){
      printf("%lld\n", pow(p[1].second - p[0].second) + pow(p[1].first - p[0].first));
    }
    else
      printf("%lld\n", solve());
  }
  exit(0);
}
